#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include <iostream>
#include <string.h>

#define INF 999999999999.0                                                      

#define EXCLENGTH 500


/*Global Variables */
long long TIMESERIES;
long long maxPageSizeTS;
int LENGTH;
int MAXREF;



/* Variables for Input and Output*/

char dirName[100];
FILE * flong;
long long overlap;
double * buffer;

/*Exclusion variables*/

long long clear;
int K;
double X;
long long *excLocs;
int ei=0;
long long *regions;
int ri=1;

/*per block variables*/
double **data1;
double **data2;
long long *ind1;
long long *ind2;
double **Dist1;
double **Dist2;
long long *locations1 , * locations2;
long long pS1, pS2;


/*Global Pointers for sorting and searching */
double **Dist;
double **data;
long long *ind;
long long * locsP;

long long *pageBoundaries;
long long numOfPages;
double * st , * en;

/*Variables Related to Reference Points */
double **dref;
int *rInd;
int iRef;
double *stdRef;
long long *refs;

/*Variables for Output*/
long long loc1 , loc2;
double bsf;
double *ts1 , *ts2;

/*Counters*/

long long countLoads = 0;
long long countDists = 0;
double diskTime;


double distance(double *x, double *y, int length , double best_so_far = INF )
{
    int i;
    double sum = 0;
    double bsf2 = best_so_far*best_so_far;

    countDists++;

    for ( i = 0 ; i < length && sum < bsf2 ; i++ )
        sum += (x[i]-y[i])*(x[i]-y[i]);
    return sqrt(sum);
    }



void error(int id)
{
    if(id==1)
        printf("ERROR : Memory can't be allocated!!!\n\n");
    else if ( id == 2 )
        printf("ERROR : File not Found!!!\n\n");
    else if ( id == 3 )
        printf("ERROR : Can't create Output File!!!\n\n");
    else if ( id == 4 )
        printf("ERROR : Invalid Number of Arguments!!!\n\n");
    else if ( id == 6 )
        printf("ERROR : Can't create page descriptors!!!\n\n");
    else if ( id == 7 )
        printf("ERROR : Page has been corrupted!!!\n\n");
    system("PAUSE");
    exit(1);

    }




void pageLoad( double **data, int p )
{

    double d;
    long long i = 0 , j  = 0;
    double ex , ex2 , mean, std;
    char tmp[5],fname[100];


    ex = ex2 = 0;

    countLoads++;

    itoa(p,tmp,10);
    strcpy(fname,dirName);
    strcat(fname,tmp);
    strcat(fname,".txt");


    FILE * fp = fopen(fname,"r");
    if( fp == NULL )
        error(2);

    while(fscanf(fp,"%lf",&d) != EOF && i < maxPageSizeTS)
    {
        data[i][j] = d;
        ex += d;
        ex2 += d*d;
        if( j == LENGTH - 1 )
        {
            mean = ex = ex/LENGTH;
            ex2 = ex2/LENGTH;
            std = sqrt(ex2-ex*ex);
            for( int k = 0 ; k < LENGTH ; k++ )
                data[i][k] = (data[i][k]-mean)/std;
            ex = ex2 = 0;
            i++;
            j = 0;
        }
        else
            j++;
    }

    fclose(fp);

}






int main(int argc , char * argv[])
{

    double d;
    long long i , j ;
    int  r = 0 , p = 0 , q = 0;
    double ex , ex2 , mean, std;
    double tExecTime, tDiskTime;
    double t1,t2,t11,t22,tt1,tt2;
    char fname[100] , tmp[5];
    long long length;
    
    long long cumLoads = 0;
    long long cumDists = 0;

    

    bsf = INF;
    i = 0;
    j = 0;
    ex = ex2 = 0;

    t11 = clock();


    LENGTH = atoi(argv[3]);
    numOfPages = atol(argv[2]);
    maxPageSizeTS = atol(argv[4]);//atol(argv[1]);

    printf("*********************   ALLOCATING MEMEORY   ********************** \n\n");

    data1 = (double **)malloc( sizeof(double *)*maxPageSizeTS);
    data2 = (double **)malloc( sizeof(double *)*maxPageSizeTS);



    if( data1 == NULL ||  data2 == NULL  )
        error(1);
    
    
    for ( i = 0 ; i < maxPageSizeTS ; i++ )
    {
        data1[i] = (double *)malloc(sizeof(double)*LENGTH);
        data2[i] = (double *)malloc(sizeof(double)*LENGTH);
        if( data1[i] ==  NULL || data2[i] == NULL )
            error(1);
    }

    strcpy(dirName,argv[1]);


    printf("*********************  SORTING : FIRST PASS    ********************** \n\n");

    t1 = clock();

    diskTime = 0;
    
    for( p = 1 ; p <= numOfPages ; p++ )
    {
        pageLoad(data1,p);

        for( q = p ; q <= numOfPages ; q++ )
        {
            pageLoad(data2,q);
            
            
            if( p == q )
            {            
                for( i = 0 ; i < maxPageSizeTS-1 ; i++ )
                    for( j = i+1 ; j < maxPageSizeTS ; j++ )
                    {
                        d = distance(data1[i],data2[j],LENGTH);
                        if( d < bsf )
                        {
                            bsf = d;
                            loc1 = (p-1)*maxPageSizeTS+i;
                            loc2 = (q-1)*maxPageSizeTS+j;
                            }
                        }
            }
            else
            {
    
                for( i = 0 ; i < maxPageSizeTS ; i++ )
                    for( j = 0 ; j < maxPageSizeTS ; j++ )
                    {
                        d = distance(data1[i],data2[j],LENGTH);
                        if( d < bsf )
                        {
                            bsf = d;
                            loc1 = (p-1)*maxPageSizeTS+i;
                            loc2 = (q-1)*maxPageSizeTS+j;
    
                            }
                        }
                }
            }
        }


    t22 = clock();
    printf("bsf %lf %lld %lld\n",bsf,loc1,loc2);
    printf("Execution time was %lf\n",(t22-t11)/CLOCKS_PER_SEC);



}
