#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <signal.h>

#define INF        999999999999.0

FILE *fp;

double *data;
long long loc1 , loc2;

long long TIMESERIES;
int LENGTH;
double bsf;
double total = 0.0;
double *d1,*d2;



/* Calculates the distance between two time series x and y. If the distance is
larger than the best so far (bsf) it stops computing and returns the approximate
distance. To get exact distance the bsf argument should be omitted.*/

double distance(double *x, double *y, int length , double best_so_far = INF )
{
    int i;
    double sum = 0;
    double bsf2 = best_so_far*best_so_far;
    for ( i = 0 ; i < length && sum < bsf2  ; i++ )
        sum += (x[i]-y[i])*(x[i]-y[i]);
    return sqrt(sum);
    }

/*Comparison function for qsort function. Compares two time series by using their
distances from the reference time series. */


    
void error(int id)
{
    if(id==1)
        printf("ERROR : Memory can't be allocated!!!\n\n");
        
    exit(1);

    }
    
    
void zNormalize(double *d,int L, double *s)
{

    double ex , ex2 , mean, std;
    int i;

    ex = 0;
    ex2 = 0;
    
    for( i = 0 ; i < L ; i++ )
    {
        ex += d[i];
        ex2 += d[i]*d[i];
    }
        
    mean = ex = ex/L;
    ex2 = ex2/L;
    std = sqrt(ex2-ex*ex);

    for( i = 0 ; i < L ; i++ )
        s[i] = (d[i]-mean)/std;
}




    
int main(  int argc , char *argv[] )
{



    double d;
    long long i , j ;
    int abandon = 0 ,  r = 0;
    long long length;
    int clear = 1;
    double t1,t2;

    /* taking inpput time series from the file in the data array and Normalizing
    them as well. */

    bsf = INF;
    i = 0;
    j = 0;


    t1 = clock();



    //arguments are in the order of filename, number of time series, length of time series, number of reference points
    fp = fopen(argv[1],"r");
    TIMESERIES = atol(argv[2]);
    LENGTH = atoi(argv[3]);

    data = (double *)malloc(sizeof(double)*TIMESERIES);
    d1 = (double *)malloc(sizeof(double)*LENGTH);
    d2 = (double *)malloc(sizeof(double)*LENGTH);


    if( data == NULL || d1 == NULL || d2 == NULL )
        error(1);


    while(fscanf(fp,"%lf",&d) != EOF && i < TIMESERIES)
        data[i++] = d;

    fclose(fp);


    clear = LENGTH-1;
    
    for( i = 0 ; i < TIMESERIES-LENGTH; i++ )
    {
        zNormalize(data+i,LENGTH,d1);
        for( j = i+clear; j < TIMESERIES-LENGTH ; j++ )
        {
            zNormalize(data+j,LENGTH,d2);

            double x = distance(d1,d2,LENGTH,bsf);
            total += x;
            if( x == 0 ) continue;
            if( bsf > x )
            {
              //  t2 = clock(); printf("%lf ,%lf\n",bsf,(t2-t1)/CLOCKS_PER_SEC);

                bsf = x;
                loc1 = i;
                loc2 = j;
              //  printf("%lf ,%lf\n",bsf,(t2-t1)/CLOCKS_PER_SEC);

                }
            }

        }

        /*Printing section of the code.*/

        printf("Motif is the pair ( %lld , %lld ) and the distance is %lf\n",loc1,loc2,bsf);
        t2 = clock(); printf("Execution Time : %lf\n",(t2-t1)/CLOCKS_PER_SEC);
   //     printf("Total is %lf\n\n\n",total);
        
/*
        double sum = 0;
        for ( r = 0 ; r < 10 ; r++ )
        {
            long long r_p = rand() % TIMESERIES;
            double minVal = INF;
            for( i = 0 ; i < TIMESERIES; i++ )
                 if( abs(i-r_p) >= clear )
                 {
                     double ll = distance( data[r_p] , data[i] , LENGTH );
                     if( ll < minVal )
                         minVal = ll;
                 }

            sum += minVal;
        }

        printf("Average nearest neighbor distance is %lf\n",sum/10);

*/


    

}
